import ErrorBoundary from './ErrorBoundary';
import type { LogEvent } from './LogEvent';
import Identity from './StatsigIdentity';
import StatsigNetwork from './StatsigNetwork';
import StatsigSDKOptions from './StatsigSDKOptions';
import { BootstrapMetadata, EvaluationDetails } from './StatsigStore';
import { StatsigUser } from './StatsigUser';
export default class StatsigLogger {
    private readonly _options;
    private readonly _identity;
    private readonly _network;
    private readonly _errorBoundary;
    private _queue;
    private _flushInterval;
    private _loggedErrors;
    private _failedLogEvents;
    private _exposureDedupeKeys;
    private _failedLogEventCount;
    constructor(options: StatsigSDKOptions, identity: Identity, network: StatsigNetwork, errorBoundary: ErrorBoundary);
    log(event: LogEvent): void;
    resetDedupeKeys(): void;
    logGateExposure(user: StatsigUser | null, gateName: string, gateValue: boolean, ruleID: string, secondaryExposures: Record<string, string>[], details: EvaluationDetails, isManualExposure: boolean, bootstrapMetadata: BootstrapMetadata | null): void;
    logConfigExposure(user: StatsigUser | null, configName: string, ruleID: string, secondaryExposures: Record<string, string>[], details: EvaluationDetails, isManualExposure: boolean, bootstrapMetadata: BootstrapMetadata | null): void;
    logLayerExposure(user: StatsigUser | null, configName: string, ruleID: string, secondaryExposures: Record<string, string>[], allocatedExperiment: string, parameterName: string, isExplicitParameter: boolean, details: EvaluationDetails, isManualExposure: boolean, bootstrapMetadata: BootstrapMetadata | null): void;
    logConfigDefaultValueFallback: (user: StatsigUser | null, message: string, metadata: object) => void;
    shutdown(): void;
    flush(isClosing?: boolean): void;
    sendSavedRequests(): Promise<void>;
    private _init;
    private _shouldLogExposure;
    private _saveFailedRequests;
    private _addFailedRequest;
    private _clearLocalStorageRequests;
    private _newFailedRequest;
}
