export declare const INIT_TIMEOUT_DEFAULT_MS = 3000;
export type StatsigEnvironment = {
    tier?: 'production' | 'staging' | 'development' | string;
    [key: string]: string | undefined;
};
export type UpdateUserCompletionCallback = (durationMs: number, success: boolean, message: string | null) => void;
export type StatsigOptions = {
    api?: string;
    disableCurrentPageLogging?: boolean;
    environment?: StatsigEnvironment;
    loggingIntervalMillis?: number;
    loggingBufferMaxSize?: number;
    disableNetworkKeepalive?: boolean;
    overrideStableID?: string;
    localMode?: boolean;
    initTimeoutMs?: number;
    disableErrorLogging?: boolean;
    disableAutoMetricsLogging?: boolean;
    initializeValues?: Record<string, any> | null;
    eventLoggingApi?: string;
    eventLoggingApiForRetries?: string;
    disableLocalStorage?: boolean;
    ignoreWindowUndefined?: boolean;
    updateUserCompletionCallback?: UpdateUserCompletionCallback;
    disableAllLogging?: boolean;
};
export default class StatsigSDKOptions {
    readonly api: string;
    readonly disableCurrentPageLogging: boolean;
    readonly environment: StatsigEnvironment | null;
    readonly loggingIntervalMillis: number;
    readonly loggingBufferMaxSize: number;
    readonly disableNetworkKeepalive: boolean;
    readonly overrideStableID: string | null;
    readonly localMode: boolean;
    readonly initTimeoutMs: number;
    readonly disableErrorLogging: boolean;
    readonly disableAutoMetricsLogging: boolean;
    readonly initializeValues: Record<string, any> | null;
    readonly eventLoggingApi: string;
    readonly eventLoggingApiForRetries: string;
    readonly disableLocalStorage: boolean;
    readonly ignoreWindowUndefined: boolean;
    readonly updateUserCompletionCallback: UpdateUserCompletionCallback | null;
    readonly disableAllLogging: boolean;
    constructor(options?: StatsigOptions | null);
    private normalizeNumberInput;
}
